Subject: RE: Active Route

From: "Martin, Christian" <[email-masked]>
Date: Wed, 2 Oct 2002 10:27:43 -0400

Jonathan,

>
>"one must focus on the rule that a BGP speaker advertises to 
>its peers (other BGP speakers which it communicates with) in 
>neighboring ASs only those routes that it itself uses."
>
>This means that if the speaker's routing table has a non-bgp 
>route to a destination but does not have bgp route to the same 
>destination (for example, based on administrative distance), 
>then the speaker may not advertise that route to it's peers. 
>This is true on Juniper by default for EBGP, but is NOT TRUE 
>[ever?] on Juniper for IBGP, and is NOT TRUE on Juniper if ~= 
>"advertise inactive" is enabled.  This is NOT TRUE ever on Cisco.
>
>Now we are proposing that the quoted clause above be 
>completely removed. This means that it will be allowable to 
>advertise a route to a destination that is not locally 
>reachable.  This is obviously (to me, but not to all-- which 
>is why it should not be removed) bad. 

This, IMO, is not the spirit of the rule.  Juniper interpreted the spec
differently.  As I see it, if the route is in the routing table, you can
announce it.  To be more specific, and to your point Jonathan, we should say
this - or say the converse:

"one must focus on the rule that a BGP speaker advertises to 
its peers (other BGP speakers which it communicates with) in 
neighboring ASs only those routes learned via BGP that it 
itself uses.  "Learned via BGP" means that a router's best path
to a prefix is one that was either learned from a BGP peer, or
deliberately injected into BGP by the local router."

Regards,
-chris

>Thank you.

---

From: [email-masked]
Date: Wed, 02 Oct 2002 17:24:56 +0200

I did not follow the whole discussion on this, however I am puzzeld with the
following situation:

I am acting as a transit AS. I receive routes via EBGP in an AS-border (router
A)  router of my AS.

Then I redistribute the routes into IGP, and at the same time I forward
the routes via IBGP (not full mesh) to all of the other AS border routers (but
to no other routers).

At the other side of my AS, I allow the border router (router B) to pass those
routes learned via IBGP (form router A) to the (next) AS via an EBGP connection.
(I am using the  "synchronise BGP = TRUE" option.)

Now in this fairly straightforward example, the router B will forward routes
learned via IBGP to the next AS using EBGP, whereas for those routes the
reachability in the FIB is taken care of by IGP (who has typically a higher
preference in ther FIB then IBGP).

So, in theory the rule : "one must focus on the rule that a BGP speaker
advertises to its peers  in neighboring ASs only those routes that it itself
uses." is broken, since it is clearly an IGP route which in the FIB.

---
Hans de Vleeschouwer

---

From: Curtis Villamizar <[email-masked]>
Date: Wed, 02 Oct 2002 12:32:40 -0400

In message <[email-masked]>, [email-masked] writ
> the routes via IBGP (not full mesh) to all of the other AS border routers (bu

This is an incredibly bad idea.  Only the BGP next_hop needs to be in
the IGP.

> (I am using the  "synchronise BGP = TRUE" option.)

Synchronise implies that the BGP next_hop is reachable via the IGP
*not* the BGP prefix itself.

There is never a need to put the destination prefix into the IGP if it
is carried in IBGP except for the case where you are originating a
prefix and you want it to go out with specific attributes such as
specific BGP communities or indicate through BGP communities some
special action such as punching a hole in an aggregate.

> uses." is broken, since it is clearly an IGP route which in the FIB.

The only way to fully address all of the instances of this sort of
objection is to add to the spec "Most BGP implementations allow the
user to do things that violate the protocol specification in minor
ways, sometimes with valid uses, but also sometimes with questionalble
uses and sometimes with dire consequences".  Although this statement
is true, I don't don't think we need to add this.

Curtis